<div id="body" class="container-fluid">
  <h6 class="mb-1">Redesign</h6>
  <h6 class="text-danger" *ngIf="isLocked">This redesign number would be opened in read only mode since {{ lockedByUser }} is working on it.</h6>
  <h6 class="text-danger"
      *ngIf="!(isSDE || isNTE || isSSE || isMDSAdmin || isMDSReviewer || isMVSAdmin || isMVSReviewer)">
    User need to be part of Sales Designer Engineer(SDE) or Network Test Engineer(NTE) or System Security Engineer(SSE) to {{ editMode ? 'create new' : 'be working on this' }} redesign request.
  </h6>

  <form [formGroup]="form" novalidate>

    <!-- Redesign Info -->
    <mat-accordion class="mb-1" *ngIf="redesignId > 0 && redesignData != null">
      <mat-expansion-panel [expanded]="true" class="mb-1">
        <mat-expansion-panel-header collapsedHeight="inherit" expandedHeight="inherit" class="card-header py-2 px-3">
          <mat-panel-title><h6>Redesign Info</h6></mat-panel-title>
        </mat-expansion-panel-header>
        <div class="form-row">
          <div class="form-group form-group-sm row col-8">
            <label class="col-form-label col-10">Redesign Number: </label>
            <label class="col-14 pl-1">{{ redesignData?.redsgnNbr }}</label>
          </div>
          <div class="form-group form-group-sm row col-8">
            <label class="col-form-label col-10">Status: </label>
            <label class="col-14 pl-1">{{ redesignData?.statusDesc }}</label>
          </div>
        </div>
      </mat-expansion-panel>
    </mat-accordion>

    <!-- Redesign Category -->
    <mat-accordion class="mb-1">
      <mat-expansion-panel [expanded]="true" class="mb-1">
        <mat-expansion-panel-header collapsedHeight="inherit" expandedHeight="inherit" class="card-header py-2 px-3">
          <mat-panel-title><h6>Redesign Category</h6></mat-panel-title>
        </mat-expansion-panel-header>
        <div class="form-row">
          <div class="form-group form-group-sm row col-10">
            <label class="col-form-label col-8 text-danger">Redesign Category: </label>
            <div class="col-16 pl-1">
              <div class="pl-2 border">
                <dx-radio-group [items]="redesignCategoryList"
                                displayExpr="redsgnCatDes"
                                valueExpr="redsgnCatId"
                                formControlName="redesignCategory"
                                layout="horizontal"
                                (onValueChanged)="onRedesignCategoriesChanged($event)">
                </dx-radio-group>
              </div>
            </div>
          </div>
        </div>
      </mat-expansion-panel>
    </mat-accordion>

    <!-- H1 Lookup -->
    <mat-accordion class="mb-1">
      <mat-expansion-panel [expanded]="true" class="mb-1">
        <mat-expansion-panel-header collapsedHeight="inherit" expandedHeight="inherit" class="card-header py-2 px-3">
          <mat-panel-title><h6>H1 Lookup</h6></mat-panel-title>
        </mat-expansion-panel-header>
        <div class="form-row">
          <div class="form-group form-group-sm row w-50"
               *ngIf="redesignId == 0 || (redesignId > 0 && redesignData?.stusId == 220)">
            <label class="col-form-label col-7 text-danger">Select Customer: </label>
            <div class="col-17 pl-0">
              <dx-select-box [dataSource]="h1CustomerLookupDS" formControlName="h1Customer"
                             displayExpr="customerH1" valueExpr="customerH1"
                             [searchEnabled]="true" [searchExpr]="['customerH1']"
                             searchMode="startswith"
                             (onValueChanged)="onH1CustomerLookupChanged($event)">
              </dx-select-box>
            </div>
          </div>
          <div class="form-group form-group-sm row w-50">
            <label class="col-form-label col-7 text-danger">H1: </label>
            <div class="col-17 pl-0">
              <div class="input-group">
                <input type="text" class="form-control form-control-sm"
                       formControlName="h1" (change)="onH1Changed()" />
                <button id="btnH1Lookup" class="btn btn-sm btn-primary" type="button" (click)="onH1Lookup()">
                  Lookup
                </button>
              </div>
              <div *ngIf="h1.invalid && (h1.dirty || h1.touched)">
                <span *ngIf="h1.errors.required" class="form-text text-danger">
                  H1 is required
                </span>
                <span *ngIf="h1.errors.invalidH1" class="form-text text-danger">
                  H1 field is not in correct format. H1 should contain 9 digits only.
                </span>
              </div>
              <div *ngIf="odieTimeout" class="form-text">
                <div class="text-danger">
                  <label>
                    H1 Lookup failed. If this is correct H1, please follow the link to have your
                    customer record updated in ODIE. When the update is complete,
                    a redesign can be initiated.
                    <a href="http://ipservices.corp.sprint.com/mns/forms/odieqda_index.php"
                       target="_blank" title="ODIE Customer record link"
                       rel="noopener noreferrer">Follow this link</a>
                  </label>
                </div>
              </div>
            </div>
          </div>
          <div class="form-group form-group-sm row w-50">
            <label class="col-form-label col-7 text-danger">Customer Name: </label>
            <div class="col-17 pl-0">
              <dx-select-box [items]="odieRspnList" formControlName="customerRspnId"
                             displayExpr="custNme" valueExpr="rspnId"
                             [searchEnabled]="true" [searchExpr]="['custNme']"
                             searchMode="startswith"
                             (onValueChanged)="onOdieCustomerNameChanged($event)">
              </dx-select-box>
            </div>
          </div>
        </div>
      </mat-expansion-panel>
    </mat-accordion>

    <!-- Contact List -->
    <app-contact-list #cntctList id="cntctList" [ngClass]="{ 'd-none': !showContactDetails }" [disabled]="!editMode"
                      [objType]="objType" [objId]="redesignId" [parent]="this"
                      [contactList]="contactList" (result)="onContactDetailSaved($event)"></app-contact-list>

    <!-- Customer Info -->
    <!--<mat-accordion class="mb-1" *ngIf="redesignId > 0 || isH1LookupClicked">
      <mat-expansion-panel [expanded]="true" class="mb-1">
        <mat-expansion-panel-header collapsedHeight="inherit" expandedHeight="inherit" class="card-header py-2 px-3">
          <mat-panel-title><h6>Customer Info</h6></mat-panel-title>
        </mat-expansion-panel-header>
        <div formGroupName="custInfo" class="mb-1">
          <div class="form-row">
            <div class="form-group form-group-sm row w-50">
              <label class="col-form-label col-7 text-danger">Customer Name: </label>
              <div class="col-17 pl-0">
                <dx-select-box [items]="odieRspnList" formControlName="customerRspnId"
                               displayExpr="custNme" valueExpr="rspnId"
                               [searchEnabled]="true" [searchExpr]="['custNme']"
                               searchMode="startswith"
                               (onValueChanged)="onOdieCustomerNameChanged($event)">
                </dx-select-box>
              </div>
            </div>
            <div class="form-group form-group-sm row w-50">
              <label class="col-form-label col-7 text-danger">Customer Team PDL:</label>
              <div class="col-17 pl-1">
                <input type="text" class="form-control form-control-sm" formControlName="custTeamPdl" />
                <div *ngIf="custTeamPdl.invalid && (custTeamPdl.dirty || custTeamPdl.touched)">
                  <span *ngIf="custTeamPdl.errors.required" class="form-text text-danger">
                    Customer Team PDL is required
                  </span>
                </div>
              </div>
            </div>
          </div>
          <div class="form-row">
            <div class="form-group form-group-sm row w-50">
              <label class="col-form-label col-7">NTE Assigned: </label>
              <div class="col-17 pl-0">
                <div class="input-group">
                  <input type="text" class="form-control form-control-sm" formControlName="nteAssigned" />
                  <app-user-finder *ngIf="option.custInfo.userFinderForNteAssigned?.isEnabled"
                                   id="nte-email" [group]="form.controls.custInfo"
                                   [option]="option.custInfo.userFinderForNteAssigned">
                  </app-user-finder>
                </div>
              </div>
            </div>
            <div class="form-group form-group-sm row w-50">
              <label class="col-form-label col-7">MSS SE Assigned: </label>
              <div class="col-17 pl-1">
                <div class="input-group">
                  <input type="text" class="form-control form-control-sm" formControlName="mssSeAssigned" />
                  <app-user-finder *ngIf="option.custInfo.userFinderForMssSeAssigned?.isEnabled"
                                   id="mss-email" [group]="form.controls.custInfo"
                                   [option]="option.custInfo.userFinderForMssSeAssigned">
                  </app-user-finder>
                </div>
              </div>
            </div>
          </div>
          <div class="form-row">
            <div class="form-group form-group-sm row w-50">
              <label class="col-form-label col-7">PM Assigned: </label>
              <div class="col-17 pl-0">
                <div class="input-group">
                  <input type="text" class="form-control form-control-sm" formControlName="pmAssigned" />
                  <app-user-finder *ngIf="option.custInfo.userFinderForPmAssigned?.isEnabled"
                                   id="pm-email" [group]="form.controls.custInfo"
                                   [option]="option.custInfo.userFinderForPmAssigned">
                  </app-user-finder>
                </div>
              </div>
            </div>
            <div class="form-group form-group-sm row w-50">
              <label class="col-form-label col-7">NE Assigned: </label>
              <div class="col-17 pl-1">
                <div class="input-group">
                  <input type="text" class="form-control form-control-sm" formControlName="neAssigned" />
                  <app-user-finder *ngIf="option.custInfo.userFinderForNeAssigned?.isEnabled"
                                   id="ne-email" [group]="form.controls.custInfo"
                                   [option]="option.custInfo.userFinderForNeAssigned">
                  </app-user-finder>
                </div>
              </div>
            </div>
          </div>
          <div class="form-row">
            <div class="form-group form-group-sm row w-100">
              <label class="offset-1">Please send an email to {{ customerEmailPDL.value }} if names assigned are incorrect.</label>
            </div>
          </div>
        </div>
      </mat-expansion-panel>
    </mat-accordion>-->

    <!-- Redesign Type -->
    <mat-accordion class="mb-1" *ngIf="redesignId > 0 || customerRspnId.value > 0">
      <mat-expansion-panel [expanded]="true" class="mb-1">
        <mat-expansion-panel-header collapsedHeight="inherit" expandedHeight="inherit" class="card-header py-2 px-3">
          <mat-panel-title><h6>Redesign Type</h6></mat-panel-title>
        </mat-expansion-panel-header>
        <div formGroupName="redesignTypeInfo">
          <div class="form-row" *ngIf="redesignId == 0">
            <div class="form-group form-group-sm row col-20">
              <label class="col-form-label col-4">Enter Device to filter: </label>
              <div class="col-20 pl-1">
                <div class="input-group">
                  <input type="text" class="form-control form-control-sm" formControlName="deviceFilter" />
                  <button type="button" class="btn btn-sm btn-primary"
                          (click)="onRedesignTypeFilterDevice()">
                    Get ODIE Devices
                  </button>
                </div>
              </div>
            </div>
          </div>
          <div class="form-row">
            <div class="form-group form-group-sm row col-24">
              <label class="col-form-label col-3 text-danger">Redesign Type: </label>
              <div class="col-21 pl-3">
                <div class="horizontalList border">
                  <dx-radio-group [items]="redesignTypeList"
                                  displayExpr="redsgnTypeNme"
                                  valueExpr="redsgnTypeId"
                                  formControlName="redesignType"
                                  layout="vertical"
                                  (onValueChanged)="onRedesignTypeChanged($event)">
                    <div *dxTemplate="let rtype of 'item'">
                      {{ rtype.redsgnTypeNme }}
                    </div>
                  </dx-radio-group>
                </div>
              </div>
            </div>
          </div>
          <div class="form-row">
            <div class="form-group form-group-sm row col-20">
              <label class="offset-4 pl-1">
                <a href="https://doc-share.corp.sprint.com/livelink/llisapi.dll?func=ll&objId=82890513&objAction=browse&viewType=1"
                   target="_blank" title="Redesign Category Link" rel="noopener noreferrer">Redesign Type Help</a>
              </label>
            </div>
          </div>
          <div class="form-row" *ngIf="redesignCategory.value > 1">
            <div class="form-group form-group-sm row col-16">
              <label class="col-form-label col-5 text-danger">SD-WAN: </label>
              <div class="col-19 pl-1">
                <dx-radio-group [items]="sdwanList" layout="horizontal"
                                displayExpr="description" valueExpr="value"
                                formControlName="sdwan">
                </dx-radio-group>
              </div>
            </div>
          </div>
          <div class="form-row">
            <div class="form-group form-group-sm row w-50">
              <label class="col-form-label col-7 text-danger">Does this device require the activation of a Cisco Smart License?</label>
              <div class="col-17 pl-0">
                <dx-radio-group [items]="ciscoSmartList" layout="horizontal"
                                displayExpr="description" valueExpr="value"
                                formControlName="ciscoSmartLicense">
                </dx-radio-group>
              </div>
            </div>
            <div class="form-group form-group-sm row w-50" *ngIf="ciscoSmartLicense?.value == 1">
              <label class="col-form-label col-7 text-danger">Smart Account Domain: </label>
              <div class="col-16 pl-1">
                <input type="text" class="form-control form-control-sm"
                       value="{{ (ciscoSmartLicense?.value == 1 ? (redesignId > 0 ? redesignData?.smrtAccntDmn : null) : null) }}"
                       formControlName="smartAccountDomain" />
                <div *ngIf="smartAccountDomain.invalid && (smartAccountDomain.dirty || smartAccountDomain.touched)">
                  <span *ngIf="smartAccountDomain.errors.pattern" class="form-text text-danger">
                    Smart Account Domain should be alpha numeric, maximum allowed characters of 100
                  </span>
                </div>
              </div>
              <label class="col-form-label col-7 text-danger">Virtual Account: </label>
              <div class="col-16 pl-1">
                <input type="text" class="form-control form-control-sm"
                       value="{{ (ciscoSmartLicense?.value == 1 ? (redesignId > 0 ? redesignData?.vrtlAccnt : null) : null) }}"
                       formControlName="virtualAccount" />
                <div *ngIf="virtualAccount.invalid && (virtualAccount.dirty || virtualAccount.touched)">
                  <span *ngIf="virtualAccount.errors.pattern" class="form-text text-danger">
                    Virtual Account should be alpha numeric, maximum allowed characters of 100
                  </span>
                </div>
              </div>
            </div>
          </div>
        </div>
      </mat-expansion-panel>
    </mat-accordion>

    <!-- Devices Info -->
    <mat-accordion class="mb-1" *ngIf="redesignId > 0 || redesignType.value > 0">
      <mat-expansion-panel [expanded]="true" class="mb-1">
        <mat-expansion-panel-header collapsedHeight="inherit" expandedHeight="inherit" class="card-header py-2 px-3">
          <mat-panel-title><h6>Devices Info</h6></mat-panel-title>
        </mat-expansion-panel-header>
        <div formGroupName="devicesInfo">
          <!-- Voice Type New Device -->
          <div class="form-row"
               *ngIf="redesignId <= 0 && redesignCategory.value == 1
                && [11,16,20,21,22,26,27,29,30,31,32].includes(redesignType.value)">
            <div class="form-group form-group-sm row col-20">
              <label class="col-form-label col-4 text-danger">Device Name: </label>
              <div class="col-20 pl-1">
                <input type="text" class="form-control form-control-sm" formControlName="newDevice" />
              </div>
            </div>
          </div>
          <!-- Data/Security New Device -->
          <div class="form-row"
               *ngIf="(redesignId <= 0
                && ((redesignCategory.value == 2 && redesignType.value == 6)
                || (redesignCategory.value == 3 && redesignType.value == 12)))">
            <div class="form-group form-group-sm row col-24">
              <label class="col-24 text-center font-weight-bolder">
                Please enter desired device name(s) into the Description field below.
              </label>
            </div>
          </div>
          <div *ngIf="redesignId > 0 || odieReqCd">
            <div class="form-row"
                 *ngIf="(redesignId > 0 && redesignData?.stusId == 222
                    && (redesignType.value == 6 || redesignType.value == 12))">
              <div class="form-group form-group-sm row col-24">
                <label class="col-24 text-center text-danger font-weight-bold">
                  For Device Add Redesigns, please see notes history for suggested device names.
                </label>
              </div>
            </div>
            <div class="form-row">
              <div class="form-group form-group-sm row col-16">
                <div class="col-24 offset-5">
                  <dx-check-box formControlName="entireNetwork"
                                text="Entire Network. Check if this request is applicable to the entire {{ customerName.value }}"
                                (onValueChanged)="onEntireNetworkChanged($event)">
                  </dx-check-box>
                </div>
              </div>
            </div>
            <div class="form-row" *ngIf="redesignId > 0 || redesignData?.systemCreatedRedesign">
              <div class="form-group form-group-sm row col-20">
                <label class="col-form-label col-4">Enter Device to filter: </label>
                <div class="col-10 pl-1">
                  <div class="input-group">
                    <input type="text" class="form-control form-control-sm" formControlName="deviceFilter" />&nbsp;
                    <button id="btnDeviceFilter" type="button" class="btn btn-sm btn-primary"
                            (click)="onDeviceInfoFilterDevice()">
                      Get ODIE Devices
                    </button>
                  </div>
                </div>
              </div>
            </div>
            <div class="form-row"
                 *ngIf="redesignId > 0 && !filterOnDeviceInfo && redesignData?.devices?.length > 0 && (!redesignData?.systemCreatedRedesign || redesignData?.stusId > 221)">
              <div class="form-group form-group-sm row col-24">
                <label class="col-form-label col-3 text-danger">Device Name: </label>
                <div class="col-21 pl-3">
                  <dx-data-grid #gridDevices id="gridDevices"
                                keyExpr="redsgnDevId" [dataSource]="redesignDevices"
                                [wordWrapEnabled]="true" [rowAlternationEnabled]="true"
                                [showBorders]="true" [disabled]="isDeviceInfoDisabled">
                    <dxo-sorting mode="multiple"></dxo-sorting>
                    <dxo-scrolling mode="standard" showScrollbar="always"
                                   useNative="false"></dxo-scrolling>
                    <dxo-editing mode="cell" [allowUpdating]="true"></dxo-editing>
                    <dxi-column dataField="isSelected" dataType="boolean" [width]="50"
                                [allowSorting]="false" headerCellTemplate="selectAll"></dxi-column>
                    <dxi-column dataField="devNme" dataType="string" caption="Device"
                                [width]="200" [allowEditing]="false"></dxi-column>
                    <dxi-column dataField="scCd" dataType="string" [width]="120"
                                caption="Simple or Complex" [allowSorting]="false"
                                [allowEditing]="redesignData?.stusId > 221"
                                headerCellTemplate="scHeaderTemplate"
                                cellTemplate="scCellTemplate" editCellTemplate="scCellTemplate">
                      <!--<dxo-lookup [dataSource]="simpleComplexList"
                                  displayExpr="description"
                                  valueExpr="value">
                      </dxo-lookup>-->
                    </dxi-column>
                    <dxi-column dataField="dispatchReadyCd" [width]="120" alignment="left"
                                caption="Dispatch Ready" [allowSorting]="false"
                                [allowEditing]="redesignData?.stusId > 221"
                                headerCellTemplate="drHeaderTemplate"
                                cellTemplate="drCellTemplate" editCellTemplate="drCellTemplate">
                      <!--<dxo-lookup [dataSource]="dispatchReadyList"
                                  displayExpr="description"
                                  valueExpr="value">
                      </dxo-lookup>-->
                    </dxi-column>
                    <dxi-column dataField="h6CustId" caption="H6" [width]="80"
                                [allowEditing]="false"></dxi-column>
                    <dxi-column dataField="eventId" caption="Event ID" [width]="80"
                                [allowEditing]="false" alignment="left"></dxi-column>
                    <dxi-column dataField="eventCmpltnDt" caption="Event Completion Date"
                                [width]="100" cellTemplate="localStartTime" [allowEditing]="false"></dxi-column>
                    <dxi-column dataField="devCmpltnCd" dataType="boolean"
                                caption="Device Completion Flag" [width]="100"
                                headerCellTemplate="dcfHeaderTemplate"
                                [allowEditing]="(isMDSAdmin || isMDSReviewer || isMVSAdmin || isMVSReviewer)"></dxi-column>
                    <div *dxTemplate="let sc of 'scHeaderTemplate'">
                      <div>Simple or Complex</div>
                      <div>
                        <dx-select-box [dataSource]="simpleComplexList"
                                       displayExpr="description" valueExpr="value"
                                       [disabled]="redesignData?.stusId <= 221"
                                       (onValueChanged)="onSelectionSCChanged($event)">
                        </dx-select-box>
                      </div>
                    </div>
                    <div *dxTemplate="let sc of 'scCellTemplate'">
                      <dx-select-box [dataSource]="simpleComplexList" [value]="sc.value"
                                     displayExpr="description" valueExpr="value"
                                     (onValueChanged)="onSCChanged(sc.key, $event.value)">
                      </dx-select-box>
                    </div>
                    <div *dxTemplate="let dr of 'drHeaderTemplate'">
                      <div>Dispatch Ready</div>
                      <div>
                        <dx-select-box [dataSource]="dispatchReadyList"
                                       displayExpr="description" valueExpr="value"
                                       [disabled]="redesignData?.stusId <= 221"
                                       (onValueChanged)="onSelectionDRChanged($event)">
                        </dx-select-box>
                      </div>
                    </div>
                    <div *dxTemplate="let dr of 'drCellTemplate'">
                      <dx-select-box [dataSource]="dispatchReadyList" [value]="dr.value"
                                     displayExpr="description" valueExpr="value"
                                     (onValueChanged)="onDRChanged(dr.key, $event.value)">
                      </dx-select-box>
                    </div>
                    <div *dxTemplate="let cell of 'localStartTime'">
                      <span>{{cell.text | date:'MM/dd/yyyy hh:mm a'}}</span>
                    </div>
                    <div *dxTemplate="let cell of 'dcfHeaderTemplate'">
                      <div class="text-left">Device Completion Flag</div>
                    </div>
                    <div *dxTemplate="let cell of 'selectAll'">
                      <dx-check-box (onValueChanged)="onDeviceSelectAll($event)"></dx-check-box>
                    </div>
                  </dx-data-grid>
                </div>
              </div>
            </div>
            <div class="form-row" *ngIf="redesignId == 0 || (redesignId > 0 && filterOnDeviceInfo)">
              <div class="form-group form-group-sm row col-24">
                <label class="col-form-label col-3 text-danger">Device Name: </label>
                <div class="col-21 pl-3">
                  <div class="mb-2 mt-2 border-checkbox-list">
                    <!--<div class="checkbox-column" formArrayName="deviceNameList"
                         *ngFor='let item of deviceNameList; let i = index'>
                      <dx-check-box [formControlName]="i"
                                    text="{{ item.text }}">displayExpr="devNme" valueExpr="devNme"
                      </dx-check-box>
                    </div>-->
                    <dx-list #listDevices [dataSource]="devicesLookupDS" height="100%"
                             [showSelectionControls]="true" [selectionMode]="multiple"
                             pageLoadMode="scrollBottom" showScrollbar="always"
                             [useNativeScrolling]="true" [selectedItemKeys]="selectedDeviceDS"
                             (onSelectionChanged)="onDeviceSelectionChanged($event)">
                    </dx-list>
                  </div>
                </div>
              </div>
            </div>
          </div>
        </div>
      </mat-expansion-panel>
    </mat-accordion>

    <!-- Redesign Docs -->
    <mat-accordion class="mb-1" *ngIf="redesignId > 0 || redesignType.value > 0">
      <mat-expansion-panel [expanded]="true" class="mb-1">
        <mat-expansion-panel-header collapsedHeight="inherit" expandedHeight="inherit" class="card-header py-2 px-3">
          <mat-panel-title><h6>Redesign Documents</h6></mat-panel-title>
        </mat-expansion-panel-header>
        <app-doc-entity-template [docList]="docList" [option]="option.documentEntity"
                                 [disabled]="isFormDisabled"></app-doc-entity-template>
        <div class="mt-3 mb-3" *ngIf="addlDocList.length > 0">
          <h6>Additonal Documents</h6>
          <div *ngFor='let item of addlDocList; let i = index'>
            <a target="_blank" rel="noopener" href="{{ item }}">{{ item }}</a>
          </div>
        </div>
      </mat-expansion-panel>
    </mat-accordion>

    <!-- Comments and Email Notifications -->
    <mat-accordion class="mb-1" *ngIf="redesignId > 0 || redesignType.value > 0">
      <mat-expansion-panel [expanded]="true" class="mb-1">
        <mat-expansion-panel-header collapsedHeight="inherit" expandedHeight="inherit" class="card-header py-2 px-3">
          <mat-panel-title><h6>Comments and Email Notifications</h6></mat-panel-title>
        </mat-expansion-panel-header>
        <div formGroupName="commentEmailInfo">
          <div class="form-row" *ngIf="redesignId > 0 && !isSDE
            && [220,221,222,223,225,230].includes(redesignData?.stusId)">
            <div class="form-group form-group-sm row col-20">
              <label class="col-form-label col-4">Caveats: </label>
              <div class="col-20 pl-1">
                <textarea class="form-control form-control-sm" formControlName="caveats" rows="5"></textarea>
              </div>
            </div>
          </div>
          <div class="form-row">
            <div class="form-group form-group-sm row col-20">
              <label class="col-form-label col-4">Description: </label>
              <div class="col-20 pl-1">
                <textarea class="form-control form-control-sm" formControlName="description" rows="5"></textarea>
              </div>
            </div>
          </div>
          <div class="form-row">
            <div class="form-group form-group-sm row col-20">
              <label class="col-form-label col-4">Email Notifications: </label>
              <div class="col-20 pl-1">
                <div class="input-group">
                  <input type="text" class="form-control form-control-sm" formControlName="emailNotifications" />
                  <app-user-finder *ngIf="option.userFinderForEmailNotifications?.isEnabled"
                                   id="email-notifications" [group]="form.controls.commentEmailInfo"
                                   [option]="option.userFinderForEmailNotifications">
                  </app-user-finder>
                </div>
              </div>
            </div>
          </div>
          <div class="form-row" *ngIf="redesignId > 0 && emailNotificationList.length > 0">
            <div class="form-group form-group-sm row col-20">
              <div class="col-20 pl-1 offset-4">
                <dx-data-grid #gridEmail id="gridEmail" [disabled]="!editMode || emailNotifications.disabled"
                              [dataSource]="emailNotificationList"
                              keyExpr="redsgnEmailNtfctnId"
                              [wordWrapEnabled]="true" [rowAlternationEnabled]="true"
                              [columnAutoWidth]="true" [showBorders]="true">
                  <dxo-sorting mode="multiple"></dxo-sorting>
                  <dxo-editing [allowDeleting]="true" [useIcons]="true"></dxo-editing>
                  <dxi-column type="buttons" [buttons]="['delete']" caption="Delete"></dxi-column>
                  <dxi-column dataField="userIdntfctnEmail" caption="Email"></dxi-column>
                </dx-data-grid>
              </div>
            </div>
          </div>
          <div class="form-row"
               *ngIf="redesignId > 0 && !helper.isEmpty(redesignData?.dsgnDocLocTxt)">
            <div class="form-group form-group-sm row col-20">
              <label class="col-form-label col-4">Link to Network Design in Netformx: </label>
              <div class="col-20 pl-1">
                <div class="input-group">
                  <input type="text" class="form-control form-control-sm" formControlName="designDocUrl" />
                  <button id="btnDesignDocUrl" type="button" class="btn btn-sm btn-primary" (click)="openDesignDocUrl()">GO</button>
                </div>
              </div>
            </div>
          </div>
          <div class="form-row">
            <div class="form-group form-group-sm row col-20">
              <label class="col-form-label col-4">Design Document Number in BPM: </label>
              <div class="col-20 pl-1">
                <input type="text" class="form-control form-control-sm" maxlength="26"
                       formControlName="designDocBPM" />
              </div>
            </div>
          </div>
        </div>
      </mat-expansion-panel>
    </mat-accordion>

    <!-- NTE Info -->
    <mat-accordion *ngIf="showNteInfo" class="mb-1">
      <mat-expansion-panel [expanded]="true" class="mb-1">
        <mat-expansion-panel-header collapsedHeight="inherit" expandedHeight="inherit" class="card-header py-2 px-3">
          <mat-panel-title><h6>NTE Info</h6></mat-panel-title>
        </mat-expansion-panel-header>
        <div formGroupName="nteInfo">
          <div class="form-row">
            <div class="form-group form-group-sm row col-24">
              <label class="col-24 text-center text-danger font-weight-bold">
                Please enter numeric value in MINUTES for Level of Effort!!!
                Value needs to be greater than 0 for Data.
              </label>
            </div>
          </div>
          <div class="form-row">
            <div class="form-group form-group-sm row col-10">
              <label class="col-form-label col-8">NTE Level of Effort: </label>
              <div class="col-16 pl-1">
                <input type="number" min="0" class="form-control form-control-sm" formControlName="nteLoe" />
              </div>
            </div>
            <div class="form-group form-group-sm row col-12" *ngIf="redesignData?.redsgnCatId == 1">
              <label class="col-form-label col-10">NTE Overtime LOE: </label>
              <div class="col-14 pl-1">
                <input type="number" min="0" class="form-control form-control-sm" formControlName="nteOtLoe" />
              </div>
            </div>
          </div>
          <div class="form-row" *ngIf="redesignData?.redsgnCatId == 1">
            <div class="form-group form-group-sm row col-10">
              <label class="col-form-label col-8">PM Level of Effort: </label>
              <div class="col-16 pl-1">
                <input type="number" min="0" class="form-control form-control-sm" formControlName="pmLoe" />
              </div>
            </div>
            <div class="form-group form-group-sm row col-12">
              <label class="col-form-label col-10">PM Overtime LOE: </label>
              <div class="col-14 pl-1">
                <input type="number" min="0" class="form-control form-control-sm" formControlName="pmOtLoe" />
              </div>
            </div>
          </div>
          <div class="form-row" *ngIf="redesignData?.redsgnCatId == 1">
            <div class="form-group form-group-sm row col-10">
              <label class="col-form-label col-8">NE Level of Effort: </label>
              <div class="col-16 pl-1">
                <input type="number" min="0" class="form-control form-control-sm" formControlName="neLoe" />
              </div>
            </div>
            <div class="form-group form-group-sm row col-12">
              <label class="col-form-label col-10">NE Overtime LOE: </label>
              <div class="col-14 pl-1">
                <input type="number" min="0" class="form-control form-control-sm" formControlName="neOtLoe" />
              </div>
            </div>
          </div>
          <div class="form-row" *ngIf="redesignData?.redsgnCatId == 1">
            <div class="form-group form-group-sm row col-10">
              <label class="col-form-label col-8">SPS Level of Effort: </label>
              <div class="col-16 pl-1">
                <input type="number" min="0" class="form-control form-control-sm" formControlName="spsLoe" />
              </div>
            </div>
            <div class="form-group form-group-sm row col-12">
              <label class="col-form-label col-10">SPS Overtime LOE: </label>
              <div class="col-14 pl-1">
                <input type="number" min="0" class="form-control form-control-sm" formControlName="spsOtLoe" />
              </div>
            </div>
          </div>
          <div class="form-row" *ngIf="redesignData?.redsgnCatId == 3">
            <div class="form-group form-group-sm row col-10">
              <label class="col-form-label col-8">MSS Implementation Estimation: </label>
              <div class="col-16 pl-1">
                <input type="number" min="1" class="form-control form-control-sm"
                       formControlName="mssImplementEst" />
              </div>
            </div>
          </div>
          <div class="form-row">
            <div class="form-group form-group-sm row col-10">
              <label class="col-form-label col-8">Redesign Type Billable?</label>
              <div class="col-16 pl-1">
                <label>{{ isBillable ? 'Yes' : 'No' }}</label>
              </div>
            </div>
            <div class="form-group form-group-sm row col-12">
              <label class="col-form-label col-10">Customer Bypass Billing?</label>
              <div class="col-14 pl-1">
                <dx-check-box formControlName="customerBypass"></dx-check-box>
              </div>
            </div>
          </div>
          <div class="form-row">
            <div class="form-group form-group-sm row col-10"
                 *ngIf="redesignData?.stusId >= 222 && !helper.isEmpty(redesignData?.costAmt)">
              <label class="col-form-label col-8">Total Cost: </label>
              <div class="col-16 pl-1">
                <input type="number" min="0" class="form-control form-control-sm" formControlName="totalCost"
                       (change)="onTotalCostChanged($event)" />
              </div>
            </div>
            <div class="form-group form-group-sm row col-12"
                 *ngIf="redesignData?.stusId >= 222 && !helper.isEmpty(redesignData?.costAmt)">
              <label class="col-form-label col-10">Cost Overridden?</label>
              <div class="col-14 pl-1">
                <dx-check-box formControlName="overrideCost"></dx-check-box>
              </div>
            </div>
          </div>
        </div>
      </mat-expansion-panel>
    </mat-accordion>

    <!-- Extend Expiration -->
    <mat-accordion class="mb-1"
                   *ngIf="redesignId > 0 && extendExpiration && isNTE">
      <mat-expansion-panel [expanded]="true" class="mb-1">
        <mat-expansion-panel-header collapsedHeight="inherit" expandedHeight="inherit" class="card-header py-2 px-3">
          <mat-panel-title><h6>Extend Expiration</h6></mat-panel-title>
        </mat-expansion-panel-header>
        <div formGroupName="extensionInfo">
          <dx-check-box formControlName="chkExtensionFlag"
                        text="Please check this to extend expiration date by 90 days.">
          </dx-check-box>
        </div>
      </mat-expansion-panel>
    </mat-accordion>

    <!-- Notes History -->
    <mat-accordion class="mb-1" *ngIf="redesignId > 0">
      <mat-expansion-panel [expanded]="true" class="mb-1">
        <mat-expansion-panel-header collapsedHeight="inherit" expandedHeight="inherit" class="card-header py-2 px-3">
          <mat-panel-title><h6>Notes History</h6></mat-panel-title>
        </mat-expansion-panel-header>
        <dx-data-grid #gridNotes id="gridNotes"
                      [dataSource]="noteHistoryList"
                      keyExpr="redsgnNotesId"
                      [wordWrapEnabled]="true" [rowAlternationEnabled]="true"
                      [showBorders]="true" [columnAutoWidth]="true">
          <dxo-sorting mode="multiple"></dxo-sorting>
          <dxo-paging [pageSize]="10"></dxo-paging>
          <dxo-pager [showPageSizeSelector]="true" [allowedPageSizes]="[10, 25, 50, 100]"></dxo-pager>
          <dxi-column dataField="redsgnNteType" caption="Note Type" dataType="string"></dxi-column>
          <dxi-column dataField="cretdBy" caption="User Name" dataType="string"></dxi-column>
          <dxi-column dataField="cretdDt" caption="Date Created" dataType="string" cellTemplate="localStartTime"></dxi-column>
          <dxi-column dataField="notes" caption="Notes" dataType="string" [encodeHtml]="false"></dxi-column>
          <div *dxTemplate="let cell of 'localStartTime'">
            <span>{{cell.text | date:'MM/dd/yyyy hh:mm a'}}</span>
          </div>
        </dx-data-grid>
      </mat-expansion-panel>
    </mat-accordion>

    <!-- Status Update -->
    <mat-accordion class="mb-1" *ngIf="redesignId > 0 || redesignType.value > 0">
      <mat-expansion-panel [expanded]="true" class="mb-1">
        <mat-expansion-panel-header collapsedHeight="inherit" expandedHeight="inherit" class="card-header py-2 px-3">
          <mat-panel-title><h6>Status Update</h6></mat-panel-title>
        </mat-expansion-panel-header>
        <div class="form-row">
          <div class="form-group form-group-sm row col-20">
            <label class="col-form-label col-4">Status: </label>
            <div class="col-20 pl-1">
              <dx-select-box [items]="statusList" formControlName="status"
                             displayExpr="description" valueExpr="value"
                             [searchEnabled]="true" [searchExpr]="['description']"
                             searchMode="startswith"
                             (onValueChanged)="onStatusUpdateChange($event)">
              </dx-select-box>
            </div>
          </div>
        </div>
        <div class="form-row">
          <div class="form-group form-group-sm row col-20">
            <label class="col-form-label col-4">Suppress Email: </label>
            <div class="col-20 pl-1">
              <dx-check-box formControlName="suppressEmails"></dx-check-box>
            </div>
          </div>
        </div>
      </mat-expansion-panel>
    </mat-accordion>

    <!-- Buttons -->
    <div class="form-row text-center">
      <div class="form-group form-group-sm col-12 col-md-6 col-lg-4"
           *ngIf="(redesignId <= 0 && redesignType.value > 0) || (!isLocked && redesignId > 0 && (isSDE || isNTE || isSSE || isMDSAdmin || isMDSReviewer || isMVSAdmin || isMVSReviewer))">
        <button type="button" class="btn btn-sm btn-primary btn-block"
                *ngIf="!isFormDisabled" (click)="save(false)">
          Save
        </button>
      </div>
      <div class="form-group form-group col-12 col-md-6 col-lg-4"
           *ngIf="(redesignId <= 0 && redesignType.value > 0) || (!isLocked && redesignId > 0 && (isSDE || isNTE || isSSE || isMDSAdmin || isMDSReviewer || isMVSAdmin || isMVSReviewer))">
        <button type="button" class="btn btn-sm btn-primary btn-block"
                *ngIf="!isFormDisabled" (click)="save(true)">
          Save & Exit
        </button>
      </div>
      <div class="form-group form-group-sm col-12 col-md-6 col-lg-4">
        <button type="button" class="btn btn-sm btn-secondary btn-block" (click)="cancel()">
          Cancel
        </button>
      </div>
    </div>
  </form>
</div>
<app-validation-summary [errors]="errors" [option]="option.validationSummaryOptions"></app-validation-summary>
